/**
 * Represents a subjective evaluation rating.
 * @constructor
 * @property {Stimulus} stimulus - Stimulus that was rated.
 * @property {Number} score - Mushra score that was given by the participant (0-100).
 * @property {Number} time - Time that the stimulus was visible in total. 
 * @property {String} attribute - Attribute that is being rated
 */
function SubjectiveEvalRating() {
    this.stimulus = null;
    this.score = null;
    this.comment = null;
    this.time = null;
    this.attribute = null;
  }