# Codebase Changes Overview

## Overview
This document outlines the changes made to the codebase to integrate a new test, `subjectiveEval`, into the existing software. The modifications include adding a new JavaScript file for page creation, updating the test logic, and configuring new audio samples and test definitions.

## Changes Made

### 1. Added New JavaScript File
- **File Added:** `SubjectiveEvalPage.js`
- **Directory:** `lib/webmushra/pages`
- **Purpose:** This file handles the page creation for the new `subjectiveEval` test.

### 2. Updated Test Logic
- **Test Added:** `subjectiveEval`
- **Integration:** Added `subjectiveEval` to the list of possible tests that can be run in the software.
- **Data Writing Logic:** Used the existing logic of the `mushra` data writing to write the output of the obtained results to the same `mushra.csv` file as the initial `mushra` page.

### 3. Configuration Updates
- **Test Definitions:**
  - Added new test definitions for `subjectiveEval` in the configuration pages.
- **Audio Samples:**
  - Added the audio samples used by the `subjectiveEval` tests in the `configs/resources/audio` directory.

### 4. Running the Software
- **Process:** The software can be run the same way as the original software, with the new test integrated seamlessly.

## Summary of Directories and Files Added/Modified
- **JavaScript Page Creation:**
  - `lib/webmushra/pages/SubjectiveEvalPage.js`
- **Test Integration:**
  - Updated the logic to include `subjectiveEval` as a runnable test.
- **Data Output:**
  - Ensured results are written to `mushra.csv` file.
- **Configurations:**
  - Added new test definitions.
  - Updated audio samples in `configs/resources/audio`.

## Conclusion
These changes expand the functionality of the software by introducing a new `subjectiveEval` test, which follows the existing data writing and test running procedures to maintain consistency and reliability.
