
svc=srevcurve(h1);
T10 = est_T60(svc, fs, [-5, -15])
T20 = est_T60(svc, fs, [-5, -25])
T30 = est_T60(svc, fs, [-5, -35])


svcBPF = srevcurve(h1_BPF);
T10 = est_T60(svcBPF, fs, [-5, -15])
T20 = est_T60(svcBPF, fs, [-5, -25])
T30 = est_T60(svcBPF, fs, [-5, -35])


figure
plot(svc)
hold on
plot(20*log10(abs(h1)/max(abs(h1))))
title('Full band')
ylim([-70 5])

figure
plot(svcBPF)
hold on
plot(20*log10(abs(h1_BPF)/max(abs(h1_BPF))))
title('500-1000')
ylim([-70 5]) 
% [h2, beta2] = rir_generator(c, fs, r, s, L, beta, n, mtype, order, dim, orientation, hp_filter);
% [y, Fs] = audioread("SA1.WAV");
% 
% hp_filter = 1;
% [h3, beta3] = rir_generator(c, fs, r, s, L, beta, n, mtype, order, dim, orientation, hp_filter);
% [y, Fs] = audioread("SA1.WAV");

% audio_out = conv(y, h1);
% 
% t_ax = 0:1/Fs:n/Fs-1/Fs;
% figure
% plot(t_ax, h1)
% hold on
% plot(t_ax, h2)
% plot(t_ax, h3)
% legend('sum to zero', 'positive', 'positive + hpf')
% xlabel('Time [s]')
% ylabel('Amplitude [-]')
% 
% 
% figure
% plot(t_ax, h1)
% xlabel('Time [s]')
% ylabel('Amplitude [-]')
% title('sum to zero')
% 
% figure
% plot(t_ax, h2)
% xlabel('Time [s]')
% ylabel('Amplitude [-]')
% title('abs')
% 
% figure
% plot(t_ax, h3)
% xlabel('Time [s]')
% ylabel('Amplitude [-]')
% title('abs + highpass')
% 

function svc=srevcurve(g)
    % SREVCURVE Schoreder's Backward integration method for more accurate decay
    % rate estimation of the reverberation time.
    
    eg=abs(g).^2;
    N = size(eg,1);
    h = ones(N,1)/N;
    svc_l=xcorr(eg, h);
    siz_svc=size(svc_l,1);
    svc_l=svc_l(ceil(siz_svc/2):siz_svc);
    svc_l(svc_l <= 0 ) = 1e-17; %in some cases there will be a numerical issue resulting in an extremely small negative value
    svc=10*log10(svc_l./svc_l(1));
end

function T60 = est_T60(svc, Fs, intercepts)
    if nargin < 3
        intercepts = [-5, -35];
        disp('Estimating T30 time');
    end
    if nargin < 2
        Fs = 1;
    end
    N = size(svc,2);
    [~, IL] = min(abs(svc-intercepts(1)));
    [~, IR] = min(abs(svc-intercepts(2)));
    T60 = 60*(IL-IR)/(intercepts(2)-intercepts(1));
    T60 = T60/Fs;
end